/* DateTime.c generated by valac 0.48.6, the Vala compiler
 * generated from DateTime.vala, do not modify */

/*
 * Copyright 2011-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <libical-glib/libical-glib.h>
#include <libecal/libecal.h>
#include <float.h>
#include <math.h>

#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

gboolean calendar_util_datetime_equal_func (GDateTime* a,
                                            GDateTime* b);
gboolean calendar_util_datetime_is_all_day (GDateTime* dtstart,
                                            GDateTime* dtend);
ICalTime* calendar_util_datetimes_to_icaltime (GDateTime* date,
                                               GDateTime* time_local,
                                               const gchar* timezone);
GDateTime* calendar_util_datetime_get_start_of_month (GDateTime* date);
GDateTime* calendar_util_datetime_strip_time (GDateTime* datetime);

gboolean
calendar_util_datetime_equal_func (GDateTime* a,
                                   GDateTime* b)
{
	gboolean result = FALSE;
	g_return_val_if_fail (a != NULL, FALSE);
	g_return_val_if_fail (b != NULL, FALSE);
	result = g_date_time_equal (a, b);
	return result;
}

/**
     * Say if an event lasts all day.
     */
gboolean
calendar_util_datetime_is_all_day (GDateTime* dtstart,
                                   GDateTime* dtend)
{
	GDateTime* utc_start = NULL;
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GTimeSpan timespan = 0LL;
	gboolean _tmp4_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (dtstart != NULL, FALSE);
	g_return_val_if_fail (dtend != NULL, FALSE);
	_tmp0_ = g_time_zone_new_utc ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_to_timezone (dtstart, _tmp1_);
	_tmp3_ = _tmp2_;
	_g_time_zone_unref0 (_tmp1_);
	utc_start = _tmp3_;
	timespan = g_date_time_difference (dtend, dtstart);
	if ((timespan % G_TIME_SPAN_DAY) == ((GTimeSpan) 0)) {
		GDateTime* _tmp5_;
		_tmp5_ = utc_start;
		_tmp4_ = g_date_time_get_hour (_tmp5_) == 0;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		result = TRUE;
		_g_date_time_unref0 (utc_start);
		return result;
	} else {
		result = FALSE;
		_g_date_time_unref0 (utc_start);
		return result;
	}
	_g_date_time_unref0 (utc_start);
}

/**
     * Converts two datetimes to one TimeType. The first contains the date,
     * its time settings are ignored. The second one contains the time itself.
     */
ICalTime*
calendar_util_datetimes_to_icaltime (GDateTime* date,
                                     GDateTime* time_local,
                                     const gchar* timezone)
{
	ICalTime* _result_ = NULL;
	ICalTime* _tmp0_;
	ICalTime* result = NULL;
	g_return_val_if_fail (date != NULL, NULL);
	_tmp0_ = i_cal_time_new_from_day_of_year (g_date_time_get_day_of_year (date), g_date_time_get_year (date));
	_result_ = _tmp0_;
	if (time_local != NULL) {
		ICalTime* _tmp5_;
		ICalTime* _tmp6_;
		if (timezone != NULL) {
			ICalTime* _tmp1_;
			ICalTimezone* _tmp2_;
			_tmp1_ = _result_;
			_tmp2_ = i_cal_timezone_get_builtin_timezone (timezone);
			i_cal_time_set_timezone (_tmp1_, _tmp2_);
		} else {
			ICalTime* _tmp3_;
			ICalTimezone* _tmp4_;
			_tmp3_ = _result_;
			_tmp4_ = e_cal_util_get_system_timezone ();
			i_cal_time_set_timezone (_tmp3_, _tmp4_);
		}
		_tmp5_ = _result_;
		i_cal_time_set_is_date (_tmp5_, FALSE);
		_tmp6_ = _result_;
		i_cal_time_set_time (_tmp6_, g_date_time_get_hour (time_local), g_date_time_get_minute (time_local), g_date_time_get_second (time_local));
	} else {
		ICalTime* _tmp7_;
		ICalTime* _tmp8_;
		_tmp7_ = _result_;
		i_cal_time_set_is_date (_tmp7_, TRUE);
		_tmp8_ = _result_;
		i_cal_time_set_time (_tmp8_, 0, 0, 0);
	}
	result = _result_;
	return result;
}

GDateTime*
calendar_util_datetime_get_start_of_month (GDateTime* date)
{
	GDateTime* _tmp1_;
	GDateTime* result = NULL;
	if (date == NULL) {
		GDateTime* _tmp0_;
		_tmp0_ = g_date_time_new_now_local ();
		_g_date_time_unref0 (date);
		date = _tmp0_;
	}
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), 1, 0, 0, (gdouble) 0);
	result = _tmp1_;
	_g_date_time_unref0 (date);
	return result;
}

GDateTime*
calendar_util_datetime_strip_time (GDateTime* datetime)
{
	GDateTime* _tmp0_;
	GDateTime* result = NULL;
	g_return_val_if_fail (datetime != NULL, NULL);
	_tmp0_ = g_date_time_add_full (datetime, 0, 0, 0, -g_date_time_get_hour (datetime), -g_date_time_get_minute (datetime), (gdouble) (-g_date_time_get_second (datetime)));
	result = _tmp0_;
	return result;
}

