/* ICalTime.c generated by valac 0.48.6, the Vala compiler
 * generated from ICalTime.vala, do not modify */

/*
 * Copyright 2011-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include <libical-glib/libical-glib.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))

GTimeZone* calendar_util_icaltime_get_timezone (ICalTime* date);
GDateTime* calendar_util_icaltime_to_datetime (ICalTime* date);

/**
     * Gets the timezone of the given TimeType as a GLib.TimeZone.
     */
static const gchar*
string_offset (const gchar* self,
               glong offset)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = (const gchar*) (((gchar*) self) + offset);
	return result;
}

GTimeZone*
calendar_util_icaltime_get_timezone (ICalTime* date)
{
	ICalTimezone* timezone = NULL;
	gchar* tzid = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp15_ = FALSE;
	ICalTimezone* _tmp16_;
	ICalTimezone* _tmp19_;
	gint is_daylight = 0;
	gint interval = 0;
	ICalTimezone* _tmp21_;
	gint _tmp22_ = 0;
	gint _tmp23_;
	gboolean is_positive = FALSE;
	gint hours = 0;
	gint minutes = 0;
	const gchar* _tmp24_ = NULL;
	gchar* hour_string = NULL;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	GTimeZone* _tmp27_;
	GTimeZone* result = NULL;
	g_return_val_if_fail (date != NULL, NULL);
	if (i_cal_time_is_date (date)) {
		GTimeZone* _tmp0_;
		g_debug ("ICalTime.vala:30: Given date is 'DATE' type, not 'DATE_TIME': Using ti" \
"mezone UTC");
		_tmp0_ = g_time_zone_new_utc ();
		result = _tmp0_;
		return result;
	}
	timezone = NULL;
	_tmp1_ = i_cal_time_get_tzid (date);
	_tmp2_ = g_strdup (_tmp1_);
	tzid = _tmp2_;
	_tmp3_ = tzid;
	if (_tmp3_ != NULL) {
		gchar* prefix = NULL;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp4_ = g_strdup ("/freeassociation.sourceforge.net/");
		prefix = _tmp4_;
		_tmp5_ = tzid;
		_tmp6_ = prefix;
		if (g_str_has_prefix (_tmp5_, _tmp6_)) {
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			const gchar* _tmp11_;
			GTimeZone* _tmp12_;
			_tmp7_ = tzid;
			_tmp8_ = prefix;
			_tmp9_ = strlen (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = string_offset (_tmp7_, (glong) _tmp10_);
			_tmp12_ = g_time_zone_new (_tmp11_);
			result = _tmp12_;
			_g_free0 (prefix);
			_g_free0 (tzid);
			return result;
		} else {
			const gchar* _tmp13_;
			GTimeZone* _tmp14_;
			_tmp13_ = tzid;
			_tmp14_ = g_time_zone_new (_tmp13_);
			result = _tmp14_;
			_g_free0 (prefix);
			_g_free0 (tzid);
			return result;
		}
		_g_free0 (prefix);
	}
	_tmp16_ = timezone;
	if (_tmp16_ == NULL) {
		ICalTimezone* _tmp17_;
		_tmp17_ = i_cal_time_get_timezone (date);
		_tmp15_ = _tmp17_ != NULL;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		ICalTimezone* _tmp18_;
		_tmp18_ = i_cal_time_get_timezone (date);
		timezone = _tmp18_;
	}
	_tmp19_ = timezone;
	if (_tmp19_ == NULL) {
		GTimeZone* _tmp20_;
		g_debug ("ICalTime.vala:66: Date has no timezone info: defaulting to UTC");
		_tmp20_ = g_time_zone_new_utc ();
		result = _tmp20_;
		_g_free0 (tzid);
		return result;
	}
	_tmp21_ = timezone;
	_tmp23_ = i_cal_timezone_get_utc_offset (_tmp21_, date, &_tmp22_);
	is_daylight = _tmp22_;
	interval = _tmp23_;
	is_positive = interval >= 0;
	interval = abs (interval);
	hours = interval / 3600;
	minutes = (interval % 3600) / 60;
	if (is_positive) {
		_tmp24_ = "+";
	} else {
		_tmp24_ = "-";
	}
	_tmp25_ = g_strdup_printf ("%s%02d:%02d", _tmp24_, hours, minutes);
	hour_string = _tmp25_;
	_tmp26_ = hour_string;
	_tmp27_ = g_time_zone_new (_tmp26_);
	result = _tmp27_;
	_g_free0 (hour_string);
	_g_free0 (tzid);
	return result;
}

/**
     * Converts the given ICal.Time to a DateTime.
     * XXX : Track next versions of evolution in order to convert ICal.Timezone to GLib.TimeZone with a dedicated function…
     */
GDateTime*
calendar_util_icaltime_to_datetime (ICalTime* date)
{
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gint second = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GTimeZone* _tmp6_;
	GTimeZone* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	GDateTime* result = NULL;
	g_return_val_if_fail (date != NULL, NULL);
	i_cal_time_get_date (date, &_tmp0_, &_tmp1_, &_tmp2_);
	year = _tmp0_;
	month = _tmp1_;
	day = _tmp2_;
	i_cal_time_get_time (date, &_tmp3_, &_tmp4_, &_tmp5_);
	hour = _tmp3_;
	minute = _tmp4_;
	second = _tmp5_;
	_tmp6_ = calendar_util_icaltime_get_timezone (date);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_date_time_new (_tmp7_, year, month, day, hour, minute, (gdouble) second);
	_tmp9_ = _tmp8_;
	_g_time_zone_unref0 (_tmp7_);
	result = _tmp9_;
	return result;
}

